#!/usr/bin/perl -w

use strict;
use POSIX qw(strftime);

my $git = `git rev-parse --short HEAD`;
chomp $git;

my $now = strftime('%Y%m%d', localtime(time));

print <<EOF;
/* DO NOT EDIT - GENERATED BY $0 */

unsigned char version[] = {
EOF

print hex2c($now, "date");
print hex2c($git, "git revision");

print "};\n\nunsigned char version_len = 8;\n";
print "\n/* EOF - this file has not been truncated */\n\n";

sub hex2c {
	my ($data, $comment) = @_;

	my $data1 = $data;
	$data1 .= '0' if (length($data1) & 1 == 1);
	$data1 =~ s/(..)/0x$1, /g;
	return "\t$data1 /* $comment $data */\n";
}

